Index: LMDZ5/branches/testing/libf/phylmd/cva_driver.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/cva_driver.F	(revision 1864)
@@ -3,5 +3,5 @@
 !
       SUBROUTINE cva_driver(len,nd,ndp1,ntra,nloc,
-     &                   iflag_con,iflag_mix,
+     &                   iflag_con,iflag_mix,iflag_ice_thermo,
      &                   iflag_clos,delt,
      &                   t1,q1,qs1,t1_wake,q1_wake,qs1_wake,s1_wake,
@@ -52,4 +52,5 @@
 C      iflag_con     Integer        Input        version of convect (3/4)
 C      iflag_mix     Integer        Input        version of mixing  (0/1/2)
+C   iflag_ice_thermo Integer        Input        accounting for ice thermodynamics (0/1)
 C      iflag_clos    Integer        Input        version of closure (0/1)
 C      delt          Real           Input        time step
@@ -155,4 +156,5 @@
       integer iflag_con
       integer iflag_mix
+      integer iflag_ice_thermo
       integer iflag_clos
       real delt
@@ -381,4 +383,5 @@
       real buoybase1(klon)
 
+      real lf1(klon,klev) ,lf1_wake(klon,klev)
       real lv1(klon,klev) ,lv1_wake(klon,klev)
       real cpn1(klon,klev),cpn1_wake(klon,klev)
@@ -419,6 +422,6 @@
       real gz(nloc,klev),h(nloc,klev)     ,hm(nloc,klev)
       real               h_wake(nloc,klev),hm_wake(nloc,klev)
-      real lv(nloc,klev)     ,cpn(nloc,klev)
-      real lv_wake(nloc,klev),cpn_wake(nloc,klev)
+      real lv(nloc,klev), lf(nloc,klev), cpn(nloc,klev)
+      real lv_wake(nloc,klev), lf_wake(nloc,klev), cpn_wake(nloc,klev)
       real p(nloc,klev),ph(nloc,klev+1),tv(nloc,klev)    ,tp(nloc,klev)
       real                              tv_wake(nloc,klev)
@@ -430,5 +433,5 @@
       real sig(nloc,klev), w0(nloc,klev), ptop2(nloc)
       real hp(nloc,klev), ep(nloc,klev), sigp(nloc,klev)
-      real frac(nloc), buoy(nloc,klev)
+      real buoy(nloc,klev)
       real cape(nloc)
       real cin(nloc)
@@ -444,10 +447,12 @@
       real sigd(nloc)
 !      real mp(nloc,klev), qp(nloc,klev), up(nloc,klev), vp(nloc,klev)
-!      real wt(nloc,klev), water(nloc,klev), evap(nloc,klev)
+!      real wt(nloc,klev), water(nloc,klev), evap(nloc,klev), ice(nloc,klev)
 !      real b(nloc,klev), sigd(nloc)
 !      save mp,qp,up,vp,wt,water,evap,b
       real, save, allocatable :: mp(:,:),qp(:,:),up(:,:),vp(:,:)
-      real, save, allocatable :: wt(:,:),water(:,:),evap(:,:), b(:,:)
-c$OMP THREADPRIVATE(mp,qp,up,vp,wt,water,evap,b)
+      real, save, allocatable :: wt(:,:),water(:,:),evap(:,:)
+      real, save, allocatable :: ice(:,:),fondue(:,:), b(:,:)
+      real, save, allocatable :: frac(:,:), faci(:,:)
+c$OMP THREADPRIVATE(mp,qp,up,vp,wt,water,evap,ice,fondue,b,frac,faci)
       real  ft(nloc,klev), fq(nloc,klev)
       real ftd(nloc,klev), fqd(nloc,klev)
@@ -496,5 +501,7 @@
          allocate(mp(nloc,klev), qp(nloc,klev), up(nloc,klev))
          allocate(vp(nloc,klev), wt(nloc,klev), water(nloc,klev))
+         allocate(ice(nloc,klev), fondue(nloc,klev))
          allocate(evap(nloc,klev), b(nloc,klev))
+         allocate(frac(nloc,klev), faci(nloc,klev))
          first=.false.
        endif
@@ -502,5 +509,5 @@
 c   (common cvflag)
 
-       CALL cv_flag
+       CALL cv_flag(iflag_ice_thermo)
 
 c -- set thermodynamical constants:
@@ -610,9 +617,9 @@
 !       print*,'t1, q1 ',t1,q1
        CALL cv3_prelim(len,nd,ndp1,t1,q1,p1,ph1      ! nd->na
-     o               ,lv1,cpn1,tv1,gz1,h1,hm1,th1)
+     o               ,lv1,lf1,cpn1,tv1,gz1,h1,hm1,th1)
     
 c
        CALL cv3_prelim(len,nd,ndp1,t1_wake,q1_wake,p1,ph1 ! nd->na
-     o               ,lv1_wake,cpn1_wake,tv1_wake,gz1_wake
+     o               ,lv1_wake,lf1_wake,cpn1_wake,tv1_wake,gz1_wake
      o               ,h1_wake,bid,th1_wake)
     
@@ -755,6 +762,6 @@
      :    ,u1,v1,gz1,th1,th1_wake
      :    ,tra1
-     :    ,h1     ,lv1     ,cpn1   ,p1,ph1,tv1    ,tp1,tvp1,clw1
-     :    ,h1_wake,lv1_wake,cpn1_wake     ,tv1_wake
+     :    ,h1     ,lv1, lf1,cpn1   ,p1,ph1,tv1    ,tp1,tvp1,clw1
+     :    ,h1_wake,lv1_wake,lf1_wake,cpn1_wake     ,tv1_wake
      :    ,sig1,w01,ptop21
      :    ,Ale1,Alp1
@@ -765,6 +772,6 @@
      o    ,u,v,gz,th,th_wake
      o    ,tra
-     o    ,h     ,lv     ,cpn    ,p,ph,tv    ,tp,tvp,clw
-     o    ,h_wake,lv_wake,cpn_wake    ,tv_wake
+     o    ,h     ,lv, lf     ,cpn    ,p,ph,tv    ,tp,tvp,clw
+     o    ,h_wake,lv_wake,lf_wake,cpn_wake    ,tv_wake
      o    ,sig,w0,ptop2
      o    ,Ale,Alp  ) 
@@ -800,6 +807,7 @@
        CALL cv3_undilute2(nloc,ncum,nd,icb,icbs,nk        !na->nd
      :                        ,tnk,qnk,gznk,hnk,t,q,qs,gz
-     :                        ,p,h,tv,lv,pbase,buoybase,plcl
-     o                        ,inb,tp,tvp,clw,hp,ep,sigp,buoy)
+     :                        ,p,h,tv,lv,lf,pbase,buoybase,plcl
+     o                        ,inb,tp,tvp,clw,hp,ep,sigp,buoy
+     :                        ,frac)
    
       endif
@@ -816,4 +824,9 @@
 !-------------------------------------------------------------------
       IF (iflag_con .eq. 3) THEN
+       if ((iflag_ice_thermo.eq.1).and.(iflag_mix.ne.0)) then
+         write(*,*) " iflag_ice_thermo==1 requires iflag_mix==0",
+     &   " but iflag_mix=",iflag_mix, ". Might as well stop here."
+         stop
+       endif
        IF (iflag_mix .ge. 1 ) THEN
          CALL zilch(supmax,nloc*klev)    
@@ -877,5 +890,5 @@
         IF (iflag_mix.eq.0) THEN
          CALL cv3_mixing(nloc,ncum,nd,nd,ntra,icb,nk,inb    ! na->nd
-     :                       ,ph,t,q,qs,u,v,tra,h,lv,qnk
+     :                       ,ph,t,q,qs,u,v,tra,h,lv,lf,frac,qnk
      :                       ,unk,vnk,hp,tv,tvp,ep,clw,m,sig
      o   ,ment,qent,uent,vent,nent,sigij,elij,ments,qents,traent)
@@ -913,8 +926,9 @@
        CALL cv3_unsat(nloc,ncum,nd,nd,ntra,icb,inb,iflag    ! na->nd
      :               ,t_wake,q_wake,qs_wake,gz,u,v,tra,p,ph
-     :               ,th_wake,tv_wake,lv_wake,cpn_wake
+     :               ,th_wake,tv_wake,lv_wake,lf_wake,cpn_wake
      :               ,ep,sigp,clw
      :               ,m,ment,elij,delt,plcl,coef_clos
-     o          ,mp,qp,up,vp,trap,wt,water,evap,b,sigd
+     o          ,mp,qp,up,vp,trap,wt,water,evap,fondue,ice
+     :          ,faci,b,sigd
      o          ,wdtrainA,wdtrainM)   ! RomP
       endif
@@ -943,7 +957,7 @@
      :                     ,icb,inb,delt
      :                     ,t,q,t_wake,q_wake,s_wake,u,v,tra
-     :                     ,gz,p,ph,h,hp,lv,cpn,th,th_wake
+     :                     ,gz,p,ph,h,hp,lv,lf,cpn,th,th_wake
      :                     ,ep,clw,m,tp,mp,qp,up,vp,trap
-     :                     ,wt,water,evap,b,sigd
+     :                     ,wt,water,ice,evap,fondue,faci,b,sigd
      :                    ,ment,qent,hent,iflag_mix,uent,vent
      :                    ,nent,elij,traent,sig
@@ -1043,3 +1057,2 @@
       return
       end
-
Index: LMDZ5/branches/testing/libf/phylmd/cvflag.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cvflag.h	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/cvflag.h	(revision 1864)
@@ -3,5 +3,6 @@
 !
       logical cvflag_grav
+      logical cvflag_ice
 
-      COMMON /cvflag/ cvflag_grav 
+      COMMON /cvflag/ cvflag_grav, cvflag_ice  
 c$OMP THREADPRIVATE(/cvflag/)
Index: LMDZ5/branches/testing/libf/phylmd/cvthermo.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/cvthermo.h	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/cvthermo.h	(revision 1864)
@@ -4,13 +4,13 @@
 c Thermodynamical constants for convectL:
 
-      real cpd, cpv, cl, rrv, rrd, lv0, g, rowl, t0
-      real clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl
+      real cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl, t0
+      real clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl, clmci
       real eps, epsi, epsim1
       real ginv, hrd
       real grav
 
-      COMMON /cvthermo/ cpd, cpv, cl, rrv, rrd, lv0, g, rowl, t0
-     :                 ,clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl 
-     :                 ,eps, epsi, epsim1, ginv, hrd, grav
+      COMMON /cvthermo/ cpd, cpv, cl, ci, rrv, rrd, lv0, lf0, g, rowl
+     :                 ,t0, clmcpv, clmcpd, cpdmcp, cpvmcpd, cpvmcl 
+     :                 ,clmci, eps, epsi, epsim1, ginv, hrd, grav
 
 c$OMP THREADPRIVATE(/cvthermo/)
Index: LMDZ5/branches/testing/libf/phylmd/declare_STDlev.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/declare_STDlev.h	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/declare_STDlev.h	(revision 1864)
@@ -1,10 +1,10 @@
 cIM for NMC files
-      real twriteSTD(klon,nlevSTD,nfiles)
-      real qwriteSTD(klon,nlevSTD,nfiles)
-      real rhwriteSTD(klon,nlevSTD,nfiles)
-      real phiwriteSTD(klon,nlevSTD,nfiles)
-      real uwriteSTD(klon,nlevSTD,nfiles)
-      real vwriteSTD(klon,nlevSTD,nfiles)
-      real wwriteSTD(klon,nlevSTD,nfiles)
+!      real twriteSTD(klon,nlevSTD,nfiles)
+!      real qwriteSTD(klon,nlevSTD,nfiles)
+!      real rhwriteSTD(klon,nlevSTD,nfiles)
+!      real phiwriteSTD(klon,nlevSTD,nfiles)
+!      real uwriteSTD(klon,nlevSTD,nfiles)
+!      real vwriteSTD(klon,nlevSTD,nfiles)
+!      real wwriteSTD(klon,nlevSTD,nfiles)
 
       real twriteSTD3(klon,nlevSTD3)
Index: LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/etat0_netcdf.F90	(revision 1864)
@@ -504,6 +504,6 @@
   zmax0(:) = 40.
   f0(:) = 1.e-5
-  ema_work1(:,:) = 0.
-  ema_work2(:,:) = 0.
+  sig1(:,:) = 0.
+  w01(:,:) = 0.
   wake_deltat(:,:) = 0.
   wake_deltaq(:,:) = 0.
Index: LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 1864)
@@ -8,5 +8,6 @@
      frac_impa, frac_nucl, beta,                        &
      prfl, psfl, rhcl, zqta, fraca,                     &
-     ztv, zpspsk, ztla, zthl, iflag_cldcon)
+     ztv, zpspsk, ztla, zthl, iflag_cldcon,             &
+     iflag_ice_thermo)
 
   !
@@ -51,6 +52,8 @@
   REAL zpspsk(klon,klev),ztla(klon,klev)
   REAL zthl(klon,klev)
+  REAL ztfondue, qsl, qsi
 
   logical lognormale(klon)
+  logical ice_thermo
 
   !AA
@@ -77,4 +80,5 @@
   INTEGER ncoreczq  
   INTEGER iflag_cldcon
+  INTEGER iflag_ice_thermo
   PARAMETER (ninter=5)
   LOGICAL evap_prec ! evaporation de la pluie
@@ -97,10 +101,14 @@
   INTEGER i, k, n, kk
   REAL zqs(klon), zdqs(klon), zdelta, zcor, zcvm5   
-  REAL zrfl(klon), zrfln(klon), zqev, zqevt
-  REAL zoliq(klon), zcond(klon), zq(klon), zqn(klon), zdelq
+  REAL zrfl(klon), zrfln(klon), zqev, zqevt 
+  REAL zifl(klon), zifln(klon), zqev0,zqevi, zqevti
+  REAL zoliq(klon), zcond(klon), zq(klon), zqn(klon), zdelq 
+  REAL zoliqp(klon), zoliqi(klon)
   REAL ztglace, zt(klon)
   INTEGER nexpo ! exponentiel pour glace/eau
   REAL zdz(klon),zrho(klon),ztot      , zrhol(klon)
   REAL zchau      ,zfroi      ,zfice(klon),zneb(klon)
+  REAL zmelt, zpluie, zice, zcondold
+  PARAMETER (ztfondue=278.15)
   !
   LOGICAL appel1er
@@ -145,4 +153,5 @@
   DATA appel1er /.TRUE./
   !ym
+  ice_thermo = iflag_ice_thermo .GE. 1
   zdelq=0.0
 
@@ -188,5 +197,13 @@
   !
   ztglace = RTT - 15.0
-  nexpo = 6
+!AJ<
+  IF (ice_thermo) THEN
+    nexpo = 2
+  ELSE
+    nexpo = 6
+  ENDIF
+!!  RLVTT = 2.501e6 ! pas de redefinition des constantes physiques (jyg)
+!!  RLSTT = 2.834e6 ! pas de redefinition des constantes physiques (jyg)
+!>AJ
   !cc      nexpo = 1
   !
@@ -223,4 +240,5 @@
      !     DO i = 1, klon
      zrfl(i) = 0.0
+     zifl(i) = 0.0
      zneb(i) = seuil_neb
   ENDDO
@@ -272,7 +290,14 @@
 
 
+     ! Calculer l'evaporation de la precipitation
+     !
+
+
      IF (evap_prec) THEN
         DO i = 1, klon
-           IF (zrfl(i) .GT.0.) THEN
+!AJ<
+!!           IF (zrfl(i) .GT.0.) THEN
+           IF (zrfl(i)+zifl(i).GT.0.) THEN
+!>AJ
               IF (thermcep) THEN
                  zdelta=MAX(0.,SIGN(1.,RTT-zt(i)))
@@ -288,29 +313,129 @@
                  ENDIF
               ENDIF
-              zqev = MAX (0.0, (zqs(i)-zq(i))*zneb(i) )
-              zqevt = coef_eva * (1.0-zq(i)/zqs(i)) * SQRT(zrfl(i)) &
-                   * (paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
-              zqevt = MAX(0.0,MIN(zqevt,zrfl(i))) &
-                   * RG*dtime/(paprs(i,k)-paprs(i,k+1))
-              zqev = MIN (zqev, zqevt)
-              zrfln(i) = zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1)) &
-                   /RG/dtime
-
-              ! pour la glace, on ré-évapore toute la précip dans la
-              ! couche du dessous
-              ! la glace venant de la couche du dessus est simplement
-              ! dans la couche du dessous.
-
-              IF (zt(i) .LT. t_coup.and.reevap_ice) zrfln(i)=0.
-
-              zq(i) = zq(i) - (zrfln(i)-zrfl(i)) &
-                   * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
-              zt(i) = zt(i) + (zrfln(i)-zrfl(i)) &
-                   * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime &
-                   * RLVTT/RCPD/(1.0+RVTMP2*zq(i))
-              zrfl(i) = zrfln(i)
-           ENDIF
-        ENDDO
-     ENDIF
+           ENDIF ! (zrfl(i)+zifl(i).GT.0.)
+        ENDDO
+!AJ<
+       IF (.NOT. ice_thermo) THEN
+        DO i = 1, klon
+!AJ<
+!!           IF (zrfl(i) .GT.0.) THEN
+           IF (zrfl(i)+zifl(i).GT.0.) THEN
+!>AJ
+                zqev = MAX (0.0, (zqs(i)-zq(i))*zneb(i) )
+                zqevt = coef_eva * (1.0-zq(i)/zqs(i)) * SQRT(zrfl(i)) &
+                     * (paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
+                zqevt = MAX(0.0,MIN(zqevt,zrfl(i))) &
+                     * RG*dtime/(paprs(i,k)-paprs(i,k+1))
+                zqev = MIN (zqev, zqevt)
+                zrfln(i) = zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1)) &
+                     /RG/dtime
+       
+                ! pour la glace, on ré-évapore toute la précip dans la
+                ! couche du dessous
+                ! la glace venant de la couche du dessus est simplement
+                ! dans la couche du dessous.
+       
+                IF (zt(i) .LT. t_coup.and.reevap_ice) zrfln(i)=0.
+       
+                zq(i) = zq(i) - (zrfln(i)-zrfl(i)) &
+                     * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
+                zt(i) = zt(i) + (zrfln(i)-zrfl(i)) &
+                     * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime &
+                     * RLVTT/RCPD/(1.0+RVTMP2*zq(i))
+                zrfl(i) = zrfln(i)
+                zifl(i) = 0.
+           ENDIF ! (zrfl(i)+zifl(i).GT.0.)
+        ENDDO
+!
+       ELSE ! (.NOT. ice_thermo) 
+!
+        DO i = 1, klon
+!AJ<
+!!           IF (zrfl(i) .GT.0.) THEN
+           IF (zrfl(i)+zifl(i).GT.0.) THEN
+!>AJ
+     !JAM !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     ! Modification de l'évaporation avec la glace
+     ! Différentiation entre précipitation liquide et solide 
+     ! On suppose que coef_evai=2*coef_eva
+     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
+     
+         zqev0 = MAX (0.0, (zqs(i)-zq(i))*zneb(i) )
+     !    zqev0 = MAX (0.0, zqs(i)-zq(i) ) 
+
+     !JAM !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     ! On différencie qsat pour l'eau et la glace
+     ! Si zdelta=1. --> glace
+     ! Si zdelta=0. --> eau liquide
+     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+         
+         qsl= R2ES*FOEEW(zt(i),0.)/pplay(i,k)
+         qsl= MIN(0.5,qsl)
+         zcor= 1./(1.-RETV*qsl)
+         qsl= qsl*zcor
+         
+         zqevt = 1.*coef_eva*(1.0-zq(i)/qsl)*SQRT(zrfl(i)) &
+              *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
+         zqevt = MAX(0.0,MIN(zqevt,zrfl(i))) &
+              *RG*dtime/(paprs(i,k)-paprs(i,k+1)) 
+
+         qsi= R2ES*FOEEW(zt(i),1.)/pplay(i,k)
+         qsi= MIN(0.5,qsi)
+         zcor= 1./(1.-RETV*qsi)
+         qsi= qsi*zcor
+
+         zqevti = 1.*coef_eva*(1.0-zq(i)/qsi)*SQRT(zifl(i)) &
+              *(paprs(i,k)-paprs(i,k+1))/pplay(i,k)*zt(i)*RD/RG
+         zqevti = MAX(0.0,MIN(zqevti,zifl(i))) &
+              *RG*dtime/(paprs(i,k)-paprs(i,k+1))   
+
+              
+     !JAM!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     ! Vérification sur l'évaporation
+     !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+     
+         IF (zqevt+zqevti.GT.zqev0) THEN
+	          zqev=zqev0*zqevt/(zqevt+zqevti)
+	          zqevi=zqev0*zqevti/(zqevt+zqevti)
+             
+         ELSE
+             IF (zqevt+zqevti.GT.0.) THEN
+	          zqev=MIN(zqev0*zqevt/(zqevt+zqevti),zqevt)
+	          zqevi=MIN(zqev0*zqevti/(zqevt+zqevti),zqevti)
+             ELSE
+             zqev=0.
+             zqevi=0.
+             ENDIF
+         ENDIF
+     
+         zrfln(i) = Max(0.,zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1)) &
+                                 /RG/dtime)
+         zifln(i) = Max(0.,zifl(i) - zqevi*(paprs(i,k)-paprs(i,k+1)) &
+                                 /RG/dtime)
+         
+     ! Pour la glace, on révapore toute la précip dans la couche du dessous
+     ! la glace venant de la couche du dessus est simplement dans la couche
+     ! du dessous.
+     
+     !    IF (zt(i) .LT. t_coup.and.reevap_ice) zrfln(i)=0.
+!         print*,zrfl(i),zrfln(i),zqevt,zqevti,RLMLT,'fluxdeprecip'
+         zq(i) = zq(i) - (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
+                  * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
+         zt(i) = zt(i) + (zrfln(i)-zrfl(i)) &
+                  * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime &
+                  * RLVTT/RCPD/(1.0+RVTMP2*zq(i)) &
+                  + (zifln(i)-zifl(i)) &
+                  * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime &
+                  * RLSTT/RCPD/(1.0+RVTMP2*zq(i))
+     
+         zrfl(i) = zrfln(i)
+         zifl(i) = zifln(i)
+
+           ENDIF ! (zrfl(i)+zifl(i).GT.0.)
+        ENDDO
+
+      ENDIF ! (.NOT. ice_thermo) 
+     
+     ENDIF ! (evap_prec)
      !
      ! Calculer Qs et L/Cp*dQs/dT:
@@ -478,6 +603,21 @@
         zq(i) = zq(i) - zcond(i)
         !         zt(i) = zt(i) + zcond(i) * RLVTT/RCPD
-        zt(i) = zt(i) + zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*zq(i))
-     ENDDO
+     ENDDO
+!AJ<
+     IF (.NOT. ice_thermo) THEN
+       DO i = 1, klon
+         zt(i) = zt(i) + zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*zq(i))
+       ENDDO
+     ELSE
+       DO i = 1, klon
+         zfice(i) = 1.0 - (zt(i)-ztglace) / (273.15-ztglace)
+         zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
+         zfice(i) = zfice(i)**nexpo
+         zt(i) = zt(i) + (1.-zfice(i))*zcond(i) * RLVTT/RCPD/(1.0+RVTMP2*zq(i)) &
+                       +zfice(i)*zcond(i) * RLSTT/RCPD/(1.0+RVTMP2*zq(i))
+!         print*,zt(i),zrfl(i),zifl(i),'temp1'
+       ENDDO
+     ENDIF
+!>AJ
      !
      ! Partager l'eau condensee en precipitation et eau liquide nuageuse
@@ -488,8 +628,23 @@
            zrho(i) = pplay(i,k) / zt(i) / RD
            zdz(i) = (paprs(i,k)-paprs(i,k+1)) / (zrho(i)*RG)
+        ENDIF
+     ENDDO
+!AJ<
+     IF (.NOT. ice_thermo) THEN
+     DO i = 1, klon
+        IF (rneb(i,k).GT.0.0) THEN
            zfice(i) = 1.0 - (zt(i)-ztglace) / (273.13-ztglace)
            zfice(i) = MIN(MAX(zfice(i),0.0),1.0)
            zfice(i) = zfice(i)**nexpo
+     !!      zfice(i)=0.
+        ENDIF
+     ENDDO
+     ENDIF
+     DO i = 1, klon
+        IF (rneb(i,k).GT.0.0) THEN
            zneb(i) = MAX(rneb(i,k), seuil_neb)
+     !      zt(i) = zt(i)+zcond(i)*zfice(i)*RLMLT/RCPD/(1.0+RVTMP2*zq(i))  
+!           print*,zt(i),'fractionglace'
+!>AJ
            radliq(i,k) = zoliq(i)/REAL(ninter+1)
         ENDIF
@@ -500,5 +655,7 @@
            IF (rneb(i,k).GT.0.0) THEN
               zrhol(i) = zrho(i) * zoliq(i) / zneb(i)
-
+              ! Initialization of zpluie and zice:
+              zpluie=0
+              zice=0
               IF (zneb(i).EQ.seuil_neb) THEN
                  ztot = 0.0
@@ -519,9 +676,23 @@
                  zchau    = zct   *dtime/REAL(ninter) * zoliq(i) &
                       *(1.0-EXP(-(zoliq(i)/zneb(i)/zcl   )**2)) *(1.-zfice(i))
-                 ztot    = zchau    + zfroi
+!AJ<
+                 IF (.NOT. ice_thermo) THEN
+                   ztot    = zchau + zfroi
+                 ELSE
+                   zpluie = MIN(MAX(zchau,0.0),zoliq(i)*(1.-zfice(i)))
+                   zice = MIN(MAX(zfroi,0.0),zoliq(i)*zfice(i)) 
+                   ztot    = zpluie    + zice
+                 ENDIF
+!>AJ
                  ztot    = MAX(ztot   ,0.0)
               ENDIF
               ztot    = MIN(ztot,zoliq(i))
+!AJ<
+     !         zoliqp = MAX(zoliq(i)*(1.-zfice(i))-1.*zpluie   , 0.0)
+     !         zoliqi = MAX(zoliq(i)*zfice(i)-1.*zice   , 0.0)
+              zoliqp(i) = MAX(zoliq(i)*(1.-zfice(i))-1.*zpluie  , 0.0)
+              zoliqi(i) = MAX(zoliq(i)*zfice(i)-1.*zice  , 0.0)
               zoliq(i) = MAX(zoliq(i)-ztot   , 0.0)
+!>AJ
               radliq(i,k) = radliq(i,k) + zoliq(i)/REAL(ninter+1)
            ENDIF
@@ -529,16 +700,67 @@
      ENDDO
      !
-     DO i = 1, klon
-        IF (rneb(i,k).GT.0.0) THEN
+         IF (.NOT. ice_thermo) THEN
+       DO i = 1, klon
+         IF (rneb(i,k).GT.0.0) THEN
            d_ql(i,k) = zoliq(i)
            zrfl(i) = zrfl(i)+ MAX(zcond(i)-zoliq(i),0.0) &
                 * (paprs(i,k)-paprs(i,k+1))/(RG*dtime)
-        ENDIF
-        IF (zt(i).LT.RTT) THEN
+         ENDIF
+       ENDDO
+     ELSE
+       DO i = 1, klon
+         IF (rneb(i,k).GT.0.0) THEN
+           d_ql(i,k) = zoliq(i)
+!AJ<
+           zrfl(i) = zrfl(i)+ MAX(zcond(i)*(1.-zfice(i))-zoliqp(i),0.0) &
+               *(paprs(i,k)-paprs(i,k+1))/(RG*dtime) 
+           zifl(i) = zifl(i)+ MAX(zcond(i)*zfice(i)-zoliqi(i),0.0) &
+                    *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)  
+     !      zrfl(i) = zrfl(i)+  zpluie                         &
+     !          *(paprs(i,k)-paprs(i,k+1))/(RG*dtime) 
+     !      zifl(i) = zifl(i)+  zice                    &
+     !               *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)                                    
+
+         ENDIF                      
+       ENDDO
+     ENDIF
+
+     IF (ice_thermo) THEN
+       DO i = 1, klon
+           zmelt = ((zt(i)-273.15)/(ztfondue-273.15))**2
+           zmelt = MIN(MAX(zmelt,0.),1.)
+           zrfl(i)=zrfl(i)+zmelt*zifl(i)
+           zifl(i)=zifl(i)*(1.-zmelt)
+!           print*,zt(i),'octavio1'
+           zt(i)=zt(i)-zifl(i)*zmelt*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
+                      *RLMLT/RCPD/(1.0+RVTMP2*zq(i))
+!           print*,zt(i),zrfl(i),zifl(i),zmelt,'octavio2'
+       ENDDO
+     ENDIF
+
+       
+     IF (.NOT. ice_thermo) THEN
+       DO i = 1, klon
+         IF (zt(i).LT.RTT) THEN
            psfl(i,k)=zrfl(i)
-        ELSE
+         ELSE
            prfl(i,k)=zrfl(i)
-        ENDIF
-     ENDDO
+         ENDIF
+       ENDDO
+     ELSE
+     ! JAM*************************************************
+     ! Revoir partie ci-dessous: à quoi servent psfl et prfl?
+     ! *****************************************************
+
+       DO i = 1, klon
+     !   IF (zt(i).LT.RTT) THEN
+           psfl(i,k)=zifl(i) 
+     !   ELSE
+           prfl(i,k)=zrfl(i)
+     !   ENDIF
+!>AJ
+       ENDDO
+     ENDIF
+     !
      !
      ! Calculer les tendances de q et de t:
@@ -604,5 +826,8 @@
   DO i = 1, klon
      IF ((t(i,1)+d_t(i,1)) .LT. RTT) THEN
-        snow(i) = zrfl(i)
+!AJ<
+!!        snow(i) = zrfl(i)
+        snow(i) = zrfl(i)+zifl(i)
+!>AJ
         zlh_solid(i) = RLSTT-RLVTT
      ELSE
Index: LMDZ5/branches/testing/libf/phylmd/hbtm.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/hbtm.F	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/hbtm.F	(revision 1864)
@@ -4,5 +4,5 @@
 
       SUBROUTINE HBTM(knon, paprs, pplay,
-     .                t2m,t10m,q2m,q10m,ustar,
+     .                t2m,t10m,q2m,q10m,ustar,wstar,
      .                flux_t,flux_q,u,v,t,q,
      .                pblh,cape,EauLiq,ctei,pblT,
@@ -54,4 +54,5 @@
       REAL q2m(klon), q10m(klon) ! q a 2 et 10m
       REAL ustar(klon)
+      REAL wstar(klon)       ! w*, convective velocity scale
       REAL paprs(klon,klev+1) ! pression a inter-couche (Pa)
       REAL pplay(klon,klev)   ! pression au milieu de couche (Pa)
@@ -158,5 +159,5 @@
       REAL fak1(klon)       ! k*ustar*pblh
       REAL fak2(klon)       ! k*wm*pblh
-      REAL fak3(klon)       ! fakn*wstr/wm
+      REAL fak3(klon)       ! fakn*wstar/wm
       REAL pblk(klon)       ! level eddy diffusivity for momentum
       REAL pr(klon)         ! Prandtl number for eddy diffusivities
@@ -164,5 +165,4 @@
       REAL zh(klon)         ! zmzp / pblh
       REAL zzh(klon)        ! (1-(zmzp/pblh))**2
-      REAL wstr(klon)       ! w*, convective velocity scale
       REAL zm(klon)         ! current level height
       REAL zp(klon)         ! current level height + one level up
@@ -625,6 +625,8 @@
           wm(i)      = ustar(i)*phiminv(i)
           fak2(i)    = wm(i)*pblh(i)*vk
-          wstr(i)    = (heatv(i)*RG*pblh(i)/zxt)**onet
-          fak3(i)    = fakn*wstr(i)/wm(i)
+          wstar(i)    = (heatv(i)*RG*pblh(i)/zxt)**onet
+          fak3(i)    = fakn*wstar(i)/wm(i)
+        ELSE
+          wstar(i)=0.
         ENDIF
 c Computes Theta_e for thermal (all cases : to be modified)
Index: LMDZ5/branches/testing/libf/phylmd/ini_histrac.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/ini_histrac.h	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/ini_histrac.h	(revision 1864)
@@ -147,5 +147,5 @@
 
 ! TD COUCHE-LIMITE
-      IF (couchelimite) THEN
+      IF (iflag_vdf_trac>=0) THEN
         CALL histdef(nid_tra, "d_tr_cl_"//tname(iiq),      &
              "tendance couche limite"// ttext(iiq), "?",   &
Index: LMDZ5/branches/testing/libf/phylmd/iniphysiq.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/iniphysiq.F	(revision 1796)
+++ LMDZ5/branches/testing/libf/phylmd/iniphysiq.F	(revision 1864)
@@ -14,5 +14,5 @@
      &                               klon_omp_end,klon_mpi_begin
       USE comgeomphy, only : airephy,cuphy,cvphy,rlond,rlatd
-
+      USE phyaqua_mod, only: iniaqua
       IMPLICIT NONE
 c
